
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "tabla2.h"

#define TRUE  1
#define FALSE 0

             // maximo de lineas (casos)
#define MAXLIN 40000
             // maximo de columnas (variables)
#define MAXCOL 800
             // tamanyo maximo de los nombres
#define MAXTNOM 80


void creaM2 (int nlt, int nc)
{
  int l;
  b = (int **) malloc (nlt * sizeof(int *));
  masc = (int **) malloc (nlt * sizeof(int *));
  v = (char **) malloc (nlt * sizeof(char *));
  for(l=0;l<nlt;l++){
    b[l]= (int *) malloc (nc * sizeof(int)) ;
    masc[l]= (int *) malloc (nc * sizeof(int)) ;
    v[l]= (char *) malloc (MAXTNOM * sizeof(char)) ;
    }
  f = (int *) malloc (nlt * sizeof(int)) ;
  tmn = (int *) malloc (nc * sizeof(int)) ;
  tmx = (int *) malloc (nc * sizeof(int)) ;
//  masc  = (int *) malloc (nc * sizeof(int)) ;
//  masc2 = (int *) malloc (nc * sizeof(int)) ;  // no hace falta
}

void umbrales ()
{
  int c, l;
  for (c=0; c<nc; c++){
    tmn[c] = b[0][c];
    tmx[c] = b[0][c];
    }
  for (c=0; c<nc; c++)
  for (l=0; l<nlt; l++){
    if (b[l][c] > tmx[c])
      tmx[c] = b[l][c];
    if (b[l][c] < tmn[c])
      tmn[c] = b[l][c];
    }
}

void leeLaTabla ()
{
  int l, c;
  int ncleidos;
  ncleidos = scanf ("%d %d", &nc, &nlt);
  if (ncleidos == 0) {
    printf ("id3: error en leeTabla leyendo el tamao\n");
    exit (1);
    }
  if (nc > MAXCOL) {
    printf ("id3: error, numero de columnas %6d mayor que MAXCOL %6d\n", nc, MAXCOL);
    exit (1);
    }
  if (nlt > MAXLIN) {
    printf ("id3: error, numero de lineas %6d mayor que MAXLIN %6d\n", nc, MAXLIN);
    exit (1);
    }
  creaM2 (nlt, nc);
  for(l=0; l<nlt; l++) {
    ncleidos = scanf ("%s", v[l]) ;
    if (ncleidos == 0) {
      printf ("id3: error en leeTabla leyendo caracter en linea %6d\n", l);
      exit (1);
      }
    for (c=0; c<nc; c++){
      ncleidos = scanf ("%d", &b[l][c]) ;
      if (ncleidos == 0) {
        printf ("id3: error en leeTabla leyendo numero %5d en linea %6d\n", c, l);
        exit (1);
        }
      }
    }
  umbrales ();
}

void fijaFunc (char * nom)
{
  int l;
  for(l=0; l<nlt; l++){
    f[l] = (strcmp(v[l],nom) == 0);
    }
}

void oFunc (char * nom2)
{
  int l;
  for(l=0; l<nlt; l++){
    if (strcmp(v[l],nom2) == 0)
      f[l] = (TRUE == TRUE);
    }
}

int parteMayorIgual (int *f, int *g, int **b, int **c, int **m, int **n,
                     int nlt, int clo, int nvo)
{
  int l, ll;
  ll=0;
  for (l=0; l<nlt; l++)
    if (b[l][clo] >= nvo){
      c[ll] = b[l];
      g[ll] = f[l];
      n[ll] = m[l];
      ll ++;
      }
  return ll;
}

int parteMenor      (int *f, int *g, int **b, int **c, int **m, int **n,
                     int nlt, int clo, int nvo)
{
  int l, ll;
  ll=0;
  for (l=0; l<nlt; l++)
    if (b[l][clo] < nvo){
      c[ll] = b[l];
      g[ll] = f[l];
      n[ll] = m[l];
      ll ++;
      }
  return ll;
}

void cuentaColNiv (int *f, int **b, int nlt,
                   int col, int niv,
                   int *c00, int *c01, int *c10,  int *c11)
{
  register int l;
  int k00, k01, k10, k11;
  k00=k01=k10=k11=0 ;
  for(l=0; l<nlt; l++)
    if (b[l][col] < niv)
      if (f[l]) k01++;
      else      k00++;
    else
      if (f[l]) k11++;
      else      k10++;
  *c00 = k00; *c01 = k01; *c10 = k10; *c11 = k11;
}

void cuentaColNiveles (int *f, int **b, int nlt,
                       int col,
                       int *cv0, int *cv1)
{
  int l;
  int n;
  for (n=tmn[col]; n<=tmx[col]; n++) {
    cv0 [n] = 0;
    cv1 [n] = 0;
    }
  for(l=0; l<nlt; l++)
    if (f[l]) cv1 [ b[l][col] ] ++ ;
    else      cv0 [ b[l][col] ] ++ ;
}

void borraMascara ()
{
  int c;
  int l;
  for (c=0; c<nc; c++) 
  for (l=0; l<nlt; l++) {
    masc [l][c] = 0;
//    masc2 [l][c] = 0;
    }
} 

void actualizaMascara ()
{
/*
  int c;
  int l;
  for (c=0; c<nc; c++) 
  for (l=0; l<nlt; l++) {
    masc [l][c] = masc2 [l][c] ;
    }
*/
} 

int sinMascara (int ** masc, int nlt, int c)
{
  int l;
  for (l=0; l<nlt; l++)
    if (masc[l][c] == 1)
      return FALSE;
  return TRUE;
}

void ponMascara (int ** masc, int nlt, int c)
{
  int l;
  for (l=0; l<nlt; l++)
    masc [l][c] = 1;
}
