
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "base.h"
// #include "glifos.h"
// #include "grises.h"
#include "grises0.h"
#include "imag.h"
// #include "inclfont.h"
#include "inclina0.h"
#include "lista.h"
#include "opcns.h"

#define NIL (0L)

int fondoClaroFijo (tvent vent)
{
  return 192;
}

int (*fondoClaro) (tvent) = fondoClaroFijo ;

timagf imagfalloc ()
{
  timagf imagf;
  imagf = (timagf) malloc (sizeof(struct teimagf));
  imagf->tx   = 0;
  imagf->ty   = 0;
  imagf->ngr  = 256;
  imagf->apixels  = (char *) NIL;
  imagf->ncom  = 0;
  imagf->comen = (char **) NIL;
  imagf->niv   = 0;
  imagf->base = imagf;
  imagf->red2 = (timagf) NIL;
  imagf->ven0 = (tvent) NIL;
  imagf->venOrig = (tvent) NIL;
  imagf->nf   = (char *) NIL;
  return imagf;
}

tvent ventalloc ()
{
  tvent vent;
  vent = (tvent) malloc (sizeof(struct tevent));
  return vent;
}

tvent ventBaseDeImagf (timagf imagf)
{
  tvent vent;
  int tx, ty, y;
  char ** v;
  vent = ventalloc ();
  vent->tx         = imagf->tx;
  vent->ty         = imagf->ty;
  vent->dx         = 0;
  vent->dy         = 0;
 // borrar jue dic 11 18:33:03 CET 2008     +30 dias
  // vent->listaVint  = (tvvents) 0L;
  vent->lvint      = (lista) 0L;
  // vent->glifoDeVen = (tglifo) 0L;
  vent->abstract   = 0L;
  vent->atributs   = listaNueva ();
  vent->carHisGr   = (struct tcaracHistoGr *) 0L;
  vent->conv       = (int *) 0L;
  vent->ktam       = -1;
  vent->venlimpia  = (tvent) 0L;
  vent->incl       =  0;
  /**/
  tx = imagf->tx;
  ty = imagf->ty;
  v = (char **) malloc (ty * sizeof(char *));
  for(y=0; y<ty; y++)
    v[y] = & (imagf->apixels[y*tx]) ;
  vent->pix     = v;
  /**/
  vent->imaBase = imagf;
  vent->venBase = vent;
  return vent;
}

void invierteGrImagen (tvent vent)
{
  int tx, ty, x, y;
  char ** pix;
  tx = vent->tx ;
  ty = vent->ty ;
  pix  = vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    pix[y][x] = 255 - (pix[y][x] & 0x0FF) ;
    }
}

// aplica la funcion   conv  a cada pixel
void cambiaGrImagen (tvent vent, int *conv)
{
  int tx, ty, x, y;
  char ** pix;
  tx = vent->tx ;
  ty = vent->ty ;
  pix  = vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    pix[y][x] = conv[(pix[y][x] & 0x0FF)] ;
    }
}

void creaImagenPlana (timagf *nimag, int g, int tx, int ty)
{
  timagf imag;
  int tam;
  int x, y;
  char ** pix;
  imag = imagfalloc ();
  imag->tx      = tx ;
  imag->ty      = ty ;
  tam = tx * ty ;
  imag->apixels = (char *) malloc (tam * sizeof(char)) ;
  imag->ven0    = ventBaseDeImagf (imag);
  /**/
  pix  = imag->ven0->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    pix[y][x] = g ;
    }
  *nimag = imag ;
}

void creaImagenReducidaDeVentana (timagf *nimagr, tvent vent, int rx, int ry)
{
  timagf imagr;
  timagf imagv;
  int txr, tyr, xr, yr, tam;
  int xr2, yr2;
  int k, kr2;
  int dx, dy;
  int sum;
  char ** pix, ** pixr;
  imagr = imagfalloc ();
  imagr->tx      = vent->tx / rx ;
  imagr->ty      = vent->ty / ry ;
  txr = imagr->tx ;
  tyr = imagr->ty ;
  tam = txr * tyr ;
  imagr->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagv = vent->imaBase ;
  imagr->ncom    = imagv->ncom ;
  imagr->comen   = imagv->comen ;
  imagr->niv     = imagv->niv + 1 ;
  imagr->base    = imagv->base ;
  imagr->nf      = imagv->nf ;
  imagr->ven0    = ventBaseDeImagf (imagr);
  pixr = imagr->ven0->pix ;
  pix  = vent->pix ;
  k   = rx * ry ;
  kr2 = k / 2;
  for (yr=0; yr<tyr; yr++)
  for (xr=0; xr<txr; xr++) {
    xr2 = xr * rx ;
    yr2 = yr * ry ;
    sum = 0 ;
    for (dx = 0; dx < rx; dx++)
    for (dy = 0; dy < ry; dy++) {
      sum += ( pix[yr2+dy][xr2+dx]   & 0x0FF ) ;
      }
    pixr [yr][xr] = ( sum + kr2 ) / k ;
    }
  *nimagr = imagr;
}

void creaImagenMaxsReducidaDeVentana (timagf *nimagr, tvent vent, int rx, int ry)
{
  timagf imagr;
  timagf imagv;
  int txr, tyr, xr, yr, tam;
  int xr2, yr2;
  int dx, dy;
  int maxgr;
  char ** pix, ** pixr;
  imagr = imagfalloc ();
  imagr->tx      = vent->tx / rx ;
  imagr->ty      = vent->ty / ry ;
  txr = imagr->tx ;
  tyr = imagr->ty ;
  tam = txr * tyr ;
  imagr->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagv = vent->imaBase ;
  imagr->ncom    = imagv->ncom ;
  imagr->comen   = imagv->comen ;
  imagr->niv     = imagv->niv + 1 ;
  imagr->base    = imagv->base ;
  imagr->nf      = imagv->nf ;
  imagr->ven0    = ventBaseDeImagf (imagr);
  pixr = imagr->ven0->pix ;
  pix  = vent->pix ;
  for (yr=0; yr<tyr; yr++)
  for (xr=0; xr<txr; xr++) {
    xr2 = xr * rx ;
    yr2 = yr * ry ;
    maxgr = 0 ;
    for (dx = 0; dx < rx; dx++)
    for (dy = 0; dy < ry; dy++) {
      int g;
      g = pix[yr2+dy][xr2+dx] & 0x0FF;
      maxgr = max(g,maxgr) ;
      }
    pixr [yr][xr] = maxgr ;
    }
  *nimagr = imagr;
}

void creaImagenReducida (timagf *nimagr, timagf imag)
{
  timagf imagr;
  int txr, tyr, xr, yr, tam;
  int xr2, yr2;
  char ** pix, ** pixr;
  imagr = imagfalloc ();
  imagr->tx      = imag->tx / 2 ;
  imagr->ty      = imag->ty / 2 ;
  txr = imagr->tx ;
  tyr = imagr->ty ;
  tam = txr * tyr ;
  imagr->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagr->ncom    = imag->ncom ;
  imagr->comen   = imag->comen ;
  imagr->niv     = imag->niv + 1 ;
  imagr->base    = imag->base ;
  imag ->red2    = imagr ;
  imagr->nf      = imag->nf ;
  imagr->ven0    = ventBaseDeImagf (imagr);
  /**/
  pixr = imagr->ven0->pix ;
  pix  = imag->ven0->pix ;
  for (yr=0; yr<tyr; yr++)
  for (xr=0; xr<txr; xr++) {
    xr2 = xr * 2 ;
    yr2 = yr * 2 ;
    pixr[yr][xr] = (
      ( pix[yr2][xr2]     & 0x0FF ) +
      ( pix[yr2][xr2+1]   & 0x0FF ) +
      ( pix[yr2+1][xr2]   & 0x0FF ) +
      ( pix[yr2+1][xr2+1] & 0x0FF ) + 2) / 4;
    }
  *nimagr = imagr;
}

void creaImagenesReducidas (timagf *vimagr, timagf imag, int n)
{
  int i;
  vimagr[0] = imag ;
  for (i=0; i<n; i++)
    creaImagenReducida ( &(vimagr[i+1]), vimagr[i]);
}

void creaImagenAmpliadaConMargen (timagf *nimaga, tvent vent,
                                  int amph, int ampv,
                                  int marg, int grMarg )
{
  timagf imaga, imag;
  int txa, tya, xa, ya, tam;
  int txa0, tya0;
  int x, y;
  char ** pix, ** pixa;
/**/
  imag  = vent->imaBase;
  imaga = imagfalloc ();
  txa0      = vent->tx * amph ;
  tya0      = vent->ty * ampv ;
  imaga->tx      = txa0 + 2 * marg ;
  imaga->ty      = tya0 + 2 * marg ;
  txa = imaga->tx ;
  tya = imaga->ty ;
  tam = txa * tya ;
  imaga->apixels = (char *) malloc (tam * sizeof(char)) ;
  imaga->ncom    = imag->ncom ;
  imaga->comen   = imag->comen ;
  imaga->niv     = 0 ;
  imaga->base    = imaga ;
  imaga->nf      = imag->nf ;
  imaga->ven0    = ventBaseDeImagf (imaga);
  imaga->venOrig = vent;
  /**/
  pixa = imaga->ven0->pix ;
  pix  = vent->pix ;
  for (ya=0; ya<tya0; ya++)
  for (xa=0; xa<txa0; xa++) {
    x = xa / amph ;
    y = ya / ampv ;
    pixa[ya+marg][xa+marg] = pix[y][x] & 0x0FF ;
    }
  if (marg > 0) {
    /* Norte , todo */
    for (ya=0; ya<marg; ya++)
    for (xa=0; xa<txa ; xa++)
      pixa[ya][xa] = grMarg ;
    /* Sur , todo */
    for (ya=0; ya<marg; ya++)
    for (xa=0; xa<txa ; xa++)
      pixa[ya+tya0+marg][xa] = grMarg ;
    /* Oeste , lateral */
    for (xa=0; xa<marg; xa++)
    for (ya=0; ya<tya0; ya++)
      pixa[ya+marg][xa] = grMarg ;
    /* Este , lateral */
    for (xa=0; xa<marg; xa++)
    for (ya=0; ya<tya0; ya++)
      pixa[ya+marg][xa+txa0+marg] = grMarg ;
    }
  *nimaga = imaga;
}

void creaImagenAmpliada (timagf *nimaga, tvent vent, int amph, int ampv)
{
  creaImagenAmpliadaConMargen (nimaga, vent, amph, ampv, 0, 0);
}

/*
void creaImagenAmpliada (timagf *nimaga, tvent vent, int amph, int ampv)
{
  timagf imaga, imag;
  int txa, tya, xa, ya, tam;
  int x, y;
  char ** pix, ** pixa;
  / ** /
  imag  = vent->imaBase;
  imaga = imagfalloc ();
  imaga->tx      = vent->tx * amph ;
  imaga->ty      = vent->ty * ampv ;
  txa = imaga->tx ;
  tya = imaga->ty ;
  tam = txa * tya ;
  imaga->apixels = (char *) malloc (tam * sizeof(char)) ;
  imaga->ncom    = imag->ncom ;
  imaga->comen   = imag->comen ;
  imaga->niv     = 0 ;
  imaga->base    = imaga ;
  imaga->nf      = imag->nf ;
  imaga->ven0    = ventBaseDeImagf (imaga);
  / ** /
  pixa = imaga->ven0->pix ;
  pix  = vent->pix ;
  for (ya=0; ya<tya; ya++)
  for (xa=0; xa<txa; xa++) {
    x = xa / amph ;
    y = ya / ampv ;
    pixa[ya][xa] = pix[y][x] & 0x0FF ;
    }
  *nimaga = imaga;
}
*/

void copiaImagenDeVentana (timagf *nimag, tvent vent)
{
  creaImagenAmpliada (nimag, vent, 1, 1);
}

void destruyeVentana (tvent vent)
{
  free (vent->pix);
  free (vent);
}

void destruyeImagen (timagf imag)
{
  destruyeVentana (imag->ven0);
  free (imag->apixels);
  free (imag); 
}

void imagenGiradaCDerecha (timagf *nimagg, tvent vent)
{
  timagf imagg;
  timagf imagb;
  int tx, ty, x, y, tam, tyr1;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  imagb = vent->imaBase ;
  imagg = imagfalloc ();
  imagg->tx      = ty;
  imagg->ty      = tx;
  tam = tx * ty;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  /**/
  tyr1 = ty - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++)
    pixg[x][tyr1-y] = pix[y][x] & 0x0FF ;
  *nimagg = imagg;
}

void imagenGiradaCIzquierda (timagf *nimagg, tvent vent)
{
  timagf imagg;
  timagf imagb;
  int tx, ty, x, y, tam, txr1;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  imagb = vent->imaBase ;
  imagg = imagfalloc ();
  imagg->tx      = ty;
  imagg->ty      = tx;
  tam = tx * ty;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  /**/
  txr1 = tx - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++)
    pixg[txr1-x][y] = pix[y][x] & 0x0FF ;
  *nimagg = imagg;
}

void imagenGiradaMVuelta (timagf *nimagg, tvent vent)
{
  timagf imagg;
  timagf imagb;
  int tx, ty, x, y, tam, txr1, tyr1;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  imagb = vent->imaBase ;
  imagg = imagfalloc ();
  imagg->tx      = tx;
  imagg->ty      = ty;
  tam = tx * ty;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  /**/
  txr1 = tx - 1;
  tyr1 = ty - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++)
    pixg[tyr1-y][txr1-x] = pix[y][x] & 0x0FF ;
  *nimagg = imagg;
}

void imagenEspejoV (timagf *nimage, tvent vent)
{
  timagf image;
  timagf imagb;
  int tx, ty, x, y, tam, txr1, tyr1;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  imagb = vent->imaBase ;
  image = imagfalloc ();
  image->tx      = tx;
  image->ty      = ty;
  tam = tx * ty;
  image->apixels = (char *) malloc (tam * sizeof(char)) ;
  image->ncom    = imagb->ncom ;
  image->comen   = imagb->comen ;
  image->niv     = 0;
  image->ven0    = ventBaseDeImagf (image);
  /**/
  txr1 = tx - 1;
  tyr1 = ty - 1;
  pixg  = image->ven0->pix ;
  pix   =        vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++)
    pixg[y][txr1-x] = pix[y][x] & 0x0FF ;
  *nimage = image;
}

/* ---------- reajusta ventana  ---------- */

void reajustaPix (tvent vent)
{
  char ** pix, ** pixi;
  int y, ty, dx, dy;
  ty   = vent->ty ;
  dy   = vent->dy ;
  dx   = vent->dx ;
  pix  = vent->imaBase->ven0->pix;
  pixi = (char **) malloc (ty * sizeof(char *));
  for (y=0; y<ty; y++)
    pixi[y] = & (pix[y+dy][dx]) ;
  free (vent->pix) ;
  vent->pix = pixi ;
}

void ventanaCreceporelNorte (tvent vent, int dely)
{
  if ((vent->dy < dely) ||
      ((vent->ty - dely) <= 0) ){
    printf ("ocre: error en imag.ventanaCreceporelNorte, fuera de limite\n");
    exit (2);
    }
  vent->dy -= dely ;
  vent->ty += dely ;
  reajustaPix (vent);
}

void ventanaCreceporelSur (tvent vent, int dely)
{
  if (((vent->dy + vent->ty + dely) > vent->imaBase->ty) ||
      ((vent->ty - dely) <= 0) ){
    printf ("ocre: error en imag.ventanaCreceporelSur, fuera de limite\n");
    // exit (2);
    }
  else {
    vent->ty += dely ;
    reajustaPix (vent);
    }
}

/* ---------- ventana en/de ventana ... ---------- */

/* La ventana construida SI DEBE estar dentro de la ventana de partida */
void ventanaEnVentana (tvent * nventi, tvent vent,
                        int dx, int dy, int tx, int ty)
{
  tvent venti;
  char ** pix, ** pixi;
  int y;
  if ((dx < 0)||(dy < 0)||
      (dx+vent->dx+tx > vent->imaBase->tx)||
      (dy+vent->dy+ty > vent->imaBase->ty)  ) {
    printf ("ocre: error en imag.ventanaEnVentana, fuera de limite\n");
    printf (" -- vent->dx:%4d vent->dy:%4d vent->tx:%4d vent->ty:%4d\n",
                 vent->dx,    vent->dy,    vent->tx,    vent->ty);
    printf (" --       dx:%4d       dy:%4d       tx:%4d       ty:%4d\n",
                       dx,          dy,          tx,          ty);
    vent = (tvent)0L; printf (" %4d \n", vent->dx);
    exit (2);
    }
  if ((tx < 0)||(ty < 0)) {
    printf ("ocre: error en imag.ventanaEnVentana, tamanyo negativo: %d,%d\n", tx, ty);
    exit (2);
    }
  venti = ventalloc ();  
  venti->tx         = tx ;
  venti->ty         = ty ;
  venti->dx         = vent->dx + dx ;
  venti->dy         = vent->dy + dy ;
 // borrar jue dic 11 18:33:03 CET 2008     +30 dias
  // venti->listaVint  = (tvvents) 0L;
  venti->lvint      = (lista) 0L;
  // venti->glifoDeVen = (tglifo) 0L;
  venti->abstract   = 0L;
  venti->atributs   = listaNueva ();
  venti->carHisGr   = (struct tcaracHistoGr *) 0L;
  venti->conv       = (int *) 0L;
  venti->ktam       = -1;
  venti->venlimpia  = (tvent) 0L;
  venti->incl       = 0;
  /**/
  venti->pix     = (char **) malloc (ty * sizeof(char *));
  pix = vent->pix ;
  pixi = venti->pix ;
  for (y=0; y<ty; y++)
/*
    pixi[y] = pix[y+dy] + dx*sizeof(char) ;
*/
    pixi[y] = & (pix[y+dy][dx]) ;
  /**/
  venti->imaBase = vent->imaBase ;
  venti->venBase = vent ;
  *nventi = venti ;
}

// cambia dx, dy, (tx, ty)   para que  venti  quepa en  vent
// intenta que el tamaño sea igual, desplaza la nueva ventana
void ventanaEnVentanaCabeIgl (tvent * nventi, tvent vent,
                             int dx, int dy, int tx, int ty)
{
  if (tx > vent->imaBase->tx)
    tx = vent->imaBase->tx ;
  if (dx < 0)
    dx = 0;
  if (dx+vent->dx+tx > vent->imaBase->tx)
    dx = vent->imaBase->tx - (vent->dx + tx) ;
  if (ty > vent->imaBase->ty)
    ty = vent->imaBase->ty ;
  if (dy < 0)
    dy = 0;
  if (dy+vent->dy+ty > vent->imaBase->ty)
    dy = vent->imaBase->ty - (vent->dy + ty) ;
  ventanaEnVentana (nventi, vent, dx, dy, tx, ty);
}

// cambia dx, dy, (tx, ty)   para que  venti  quepa en  vent
// la ventana nueva es la interseccion de la vent. pedida y la vent. base
void ventanaEnVentanaCabeMen (tvent * nventi, tvent vent,
                             int dx, int dy, int tx, int ty)
{
  if (tx > vent->imaBase->tx)
    tx = vent->imaBase->tx ;
  if (dx < 0) {
    tx += dx;
    dx = 0;
    }
  if (dx+vent->dx+tx > vent->imaBase->tx)
    tx = vent->imaBase->tx - (vent->dx + dx);

  if (ty > vent->imaBase->ty)
    ty = vent->imaBase->ty ;
  if (dy < 0) {
    ty += dy;
    dy = 0;
    }
  if (dy+vent->dy+ty > vent->imaBase->ty)
    ty = vent->imaBase->ty - (vent->dy + dy);
  ventanaEnVentana (nventi, vent, dx, dy, tx, ty);
}

void ventanaEnVentanaCentrada (tvent * nventi, tvent vent,
                               int dx, int dy )
{
  ventanaEnVentana (nventi, vent, dx, dy, vent->tx-2*dx,vent->ty-2*dy);
}

/* La ventana construida PUEDE NO estar dentro de la ventana de partida */
void ventanaDeVentana (tvent * nventi, tvent vent,
                        int dx, int dy, int tx, int ty)
{
  ventanaEnVentana (nventi, vent->imaBase->ven0,
                    vent->dx+dx,
                    vent->dy+dy,
                    tx, ty);
}

void ventanaDeVentanaCabeMen (tvent * nventi, tvent vent,
                              int dx, int dy, int tx, int ty)
{
  ventanaEnVentanaCabeMen (nventi, vent->imaBase->ven0,
                           vent->dx+dx,
                           vent->dy+dy,
                           tx, ty);
}

// modificaciones -> tambien en  aclaraOeste
void aclaraNorte (tvent vent, int inclH, int y0, int gr)
{
  int x, y, yul;
  int x00, x11, x0, x1;      // limites: x0..tx-1,  0..x1
  int tx;
  char ** pix; 
  tx = vent->tx ;
  pix  = vent->pix ;
  // printf ("inclH: %4d, y0: %4d\n", inclH, y0);
  if (inclH == 0) {
    for (y=0; y<y0; y++) 
    for (x=0; x<tx;  x++) 
      pix[y][x] = gr ;
    }
  else if (inclH > 0) {
    yul = y0 + inclf_desvx(inclH,tx-1);
    for (y=0; y<=yul; y++) {
      x00 = ( (y-y0)*K64 - K32 ) / inclH;
      x0 = max(0,x00);
      for (x=x0; x<tx; x++)
        pix[y][x] = gr ;
      }
    }
  else {  // inclH < 0
    yul = y0;
    for (y=0; y<=yul; y++) {
      x11 = ( (y-y0)*K64 + K32 ) / inclH;
      x1 = min(x11,tx);
      for (x=0; x<x1; x++)
        pix[y][x] = gr ;
      }
    }
}

// modificaciones -> tambien en  aclaraEste
void aclaraSur   (tvent vent, int inclH, int y1, int gr)
{
  int x, y, ypri;
  int x00, x11, x0, x1;      // limites: x0..tx-1,  0..x1
  int tx, ty;
  char ** pix; 
  tx = vent->tx ;
  ty = vent->ty ;
  pix  = vent->pix ;
  //  printf ("inclH: %4d, y1: %4d\n", inclH, y1);
  //  printf ("tx: %4d, ty: %4d\n", tx, ty);
  if (inclH == 0) {
    for (y=y1+1; y<ty; y++) 
    for (x=0; x<tx;  x++) 
      pix[y][x] = gr ;
    }
  else if (inclH > 0) {
    ypri = y1;
    for (y=ypri; y<ty; y++) {
      x11 = ( (y-y1)*K64 + K32 ) / inclH;
      x1 = min (x11,tx);
      for (x=0; x<x1; x++)
        pix[y][x] = gr ;
      }
    }
  else {  // inclH < 0
    ypri = y1 + inclf_desvx(inclH,tx-1);
    for (y=ypri; y<ty; y++) {
      x00 = ( (y-y1)*K64 + K32 ) / inclH;
      x0 = max(0,x00);
      for (x=x0; x<tx; x++)
        pix[y][x] = gr ;
      }
    }
  //  printf ("ypri: %4d\n", ypri);
}

// COPIA de aclaraNorte   tr xyH  yxV    salvo en  pix[y][x]
void aclaraOeste (tvent vent, int inclV, int x0, int gr)
{
  int x, y, xul;
  int y00, y11, y0, y1;      // limites: y0..ty-1,  0..y1
  int ty;
  char ** pix; 
  ty = vent->ty ;
  pix  = vent->pix ;
  // printf ("inclV: %4d, x0: %4d\n", inclH, x0);
  if (inclV == 0) {
    for (x=0; x<x0; x++) 
    for (y=0; y<ty;  y++) 
      pix[y][x] = gr ;
    }
  else if (inclV > 0) {
    xul = x0 + inclf_desvx(inclV,ty-1);
    for (x=0; x<=xul; x++) {
      y00 = ( (x-x0)*K64 - K32 ) / inclV;
      y0 = max(0,y00);
      for (y=y0; y<ty; y++)
        pix[y][x] = gr ;
      }
    }
  else {  // inclV < 0
    xul = x0;
    for (x=0; x<=xul; x++) {
      y11 = ( (x-x0)*K64 + K32 ) / inclV;
      y1 = min(y11,ty);
      for (y=0; y<y1; y++)
        pix[y][x] = gr ;
      }
    }
}

// COPIA de aclaraSur     tr xyH  yxV    salvo en  pix[y][x]
void aclaraEste  (tvent vent, int inclV, int x1, int gr)
{
  int x, y, xpri;
  int y00, y11, y0, y1;      // limites: x0..tx-1,  0..x1
  int tx, ty;
  char ** pix; 
  tx = vent->tx ;
  ty = vent->ty ;
  pix  = vent->pix ;
  //  printf ("inclV: %4d, x1: %4d\n", inclV, x1);
  //  printf ("tx: %4d, ty: %4d\n", tx, ty);
  if (inclV == 0) {
    for (x=x1+1; x<tx; x++) 
    for (y=0; y<ty;  y++) 
      pix[y][x] = gr ;
    }
  else if (inclV > 0) {
    xpri = x1;
    for (x=xpri; x<tx; x++) {
      y11 = ( (x-x1)*K64 + K32 ) / inclV;
      y1 = min (y11,ty);
      for (y=0; y<y1; y++)
        pix[y][x] = gr ;
      }
    }
  else {  // inclV < 0
    xpri = x1 + inclf_desvx(inclV,ty-1);
    for (x=xpri; x<tx; x++) {
      y00 = ( (x-x1)*K64 + K32 ) / inclV;
      y0 = max(0,y00);
      for (y=y0; y<ty; y++)
        pix[y][x] = gr ;
      }
    }
  //  printf ("xpri: %4d\n", xpri);
}

void ventanaLimpParalogrDeVentana (tvent * nventi, tvent vent,
                              int inclH, int y0, int y1, int inclV, int x0, int x1)
{
  struct tecuadrltr cuad;
  tvent venti;
  timagf imag;
  int fondo;
  int dxr, dyr;   // desplazamiento relativo a la ventana anterior.
  pon_paralogr (inclH, y0, y1, inclV, x0, x1, &cuad);
  // imprime_paralogr (& cuad);
  ventanaDeVentanaCabeMen (&venti, vent, cuad.x0, cuad.y0,
                            cuad.x1 - cuad.x0 + 1, cuad.y1 - cuad.y0 + 1);
  dxr = venti->dx - vent->dx;
  dyr = venti->dy - vent->dy;
  copiaImagenDeVentana (&imag, venti);
  fondo = fondoClaro (vent);
  aclaraNorte (imag->ven0, inclH, y0 + inclf_desvx(inclH,dxr) - dyr, fondo);
  aclaraSur   (imag->ven0, inclH, y1 + inclf_desvx(inclH,dxr) - dyr, fondo);
  aclaraOeste (imag->ven0, inclV, x0 + inclf_desvx(inclV,dyr) - dxr, fondo);
  aclaraEste  (imag->ven0, inclV, x1 + inclf_desvx(inclV,dyr) - dxr, fondo);
  * nventi = imag->ven0;
}

void copiaVentana (tvent * nventi, tvent vent)
{
  ventanaEnVentana (nventi, vent, 0, 0, vent->tx, vent->ty);
}

void copiaVentanaaImagen (timagf imag, tvent vent, int dx, int dy)
{
  char ** pix, ** pixd;
  int tx, ty;
  int x, y;
  tvent ventd;
  if ((dx < 0) || (dy < 0) ||
      (imag->tx < (vent->tx + dx)) ||
      (imag->ty < (vent->ty + dy))) {
    printf ("ocre: error en imag.copiaVentanaaImagen, fuera de limite\n");
    printf (" -- imag->tx:%4d imag->ty:%4d vent->tx:%4d vent->ty:%4d\n",
                 imag->tx,    imag->ty,    vent->tx,    vent->ty);
    printf (" --       dx:%4d       dy:%4d\n",
                       dx,          dy);
    vent = (tvent)0L; printf (" %4d \n", vent->dx);
    exit (2);
    }
  ventanaEnVentana (&ventd, imag->ven0, dx, dy, vent->tx, vent->ty);
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pixd = ventd->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++){
    pixd[y][x] =  (pix[y][x] & 0x0FF) ;
    }
}

void ventanaEnVentanaLargHor (tvent * nventi, tvent vent, int dy, int ty)
{
  ventanaEnVentana (nventi, vent, 0, dy, vent->tx, ty);
}

void ventanaEnVentanaLargVer (tvent * nventi, tvent vent, int dx, int tx)
{
  ventanaEnVentana (nventi, vent, dx, 0, tx, vent->ty);
}

void ventanaEnVentanaLargVerInclLimpConMargen (tvent * nventi, tvent vent,
		                               int dxb, int txb, int inclvabs)
{
  tvent vent1;
//  tdcaracHistoGr carHisGr;
  int fondo;
  if (inclvabs > 0) {
    ventanaEnVentanaLargVer (&vent1, vent, dxb, min(txb+inclvabs,vent->tx-dxb));
//    vent1->tx   = min(txb, vent->tx - dxb - inclvabs);
    }
  else {
    ventanaEnVentanaLargVer (&vent1, vent, max(dxb+inclvabs,0), txb + inclvabs);
//    vent1->tx   =  vent->tx - min (0, dxb + inclvabs) ;
    }
//  vent1->incl = (inclvabs * 256 + 128) / vent->ty ;
  vent1->incl = (inclvabs * 256 * 256) / vent->ty ;
/*
  carHisGr = carhisgrDeVentana (vent);
  fondo = carHisGr->xblanco ;
  fondo = 192;
  fondo = fondoClaroFijo (vent);
*/
  fondo = fondoClaro (vent);
  ventanaLimpConMargenDeVentanaIncl (nventi, vent1, fondo, 5);
}

void ventanaAmpliaVentana (tvent * nventi, tvent vent,
                               int marg )
{
  int dx, dy, fx, fy, tx, ty;
  tvent vB ;
  vB = vent->imaBase->ven0;
  dx = max(0, vent->dx - marg);
  dy = max(0, vent->dy - marg);
  fx = min(vB->tx-1, vent->dx+vent->tx-1+marg);
  fy = min(vB->ty-1, vent->dy+vent->ty-1+marg);
  tx = fx-dx+1;
  ty = fy-dy+1;
  ventanaEnVentana (nventi, vB, dx, dy, tx, ty);
  (*nventi)->venBase = vent->venBase;
}

tvvents vventsalloc (int n)
{
  tvvents vvents;
  vvents = (tvvents) malloc (sizeof(struct tevvents)); 
  vvents->n = n;
  vvents->ventanas = (tvent *) malloc(n * sizeof(tvent));
  return vvents ;
}

void vventsfree (tvvents vvents)
{
  free (vvents->ventanas);
  free (vvents) ; 
}

void desplazaBase (int nivr)
{
  printf ("%*s", nivr*3, "");
}

void describeVentana0 (tvent vent, int nivr)
{
  desplazaBase (nivr);
  printf ("ventana, tamanyo:%dx%d, desplazamiento: %4d,%4d inclinacion: %4d\n",
           vent->tx, vent->ty, vent->dx, vent->dy, vent->incl);
  if (vent->venlimpia == 0L) {
    desplazaBase (nivr);
    printf ("ventana limpia\n");
    }
  if (vent->imaBase->venOrig != 0){
    desplazaBase (nivr);
    printf ("base:\n");
    describeVentana0 (vent->imaBase->venOrig, nivr+1);
    }
  if (vent->lvint == (lista)0L) {
    desplazaBase (nivr);
    printf ("ventana sin subventanas\n");
    }
  else {
    desplazaBase (nivr);
    printf ("ventana con subventanas: %3d\n", longLista (vent->lvint));
    }
//  if (vent->abstract   != 0L)
//    printf ("vent.   contenido: %s\n", vent->glifoDeVen->letras);
//    printf ("vent.   contenido: %s\n", vent->abstract->letras);
}

void describeVentana (tvent vent)
{
  describeVentana0 (vent, 0);
}

void describeVventanas (tvvents vvents)
{
  int i;
  printf ("vector ventanas, numero: %4d\n", vvents->n);
  for (i=0; i < vvents->n; i++) {
    printf ("%03d", i);
    describeVentana (vvents->ventanas[i]);
    }
}

void desplazamientosBase (int *dx, int *dy, int* tx, int *ty, tvent vent)
{
  int dxl, dyl, dxb, dyb;
  dxl = vent->dx;
  dyl = vent->dy;
  if (vent->imaBase->venOrig != 0) {
    desplazamientosBase (&dxb, &dyb, tx, ty, vent->imaBase->venOrig);
    dxl += dxb;
    dyl += dyb;
    }
  else {
    *tx = vent->venBase->tx;
    *ty = vent->venBase->ty;
    }
  *dx = dxl;
  *dy = dyl;
}

void desplazamientosBase2 (int *dx, int *dy, tvent vent)
{
  int dxl, dyl, dxb, dyb;
  dxl = vent->dx;
  dyl = vent->dy;
  if (vent->imaBase->venOrig != 0) {
    desplazamientosBase2 (&dxb, &dyb, vent->imaBase->venOrig);
    dxl += dxb - 5;
    dyl += dyb - 5;
    }
  *dx = dxl;
  *dy = dyl;
}

/*
void ponerCarhisgrenVentana (tvent vent, tdcaracHistoGr carHisGr)
{
  vent->carHisGr = (tdcaracHistoGr) malloc (sizeof(struct tcaracHistoGr));
  vent->carHisGr->xblanco  = carHisGr->xblanco ;
  vent->carHisGr->xnegro   = carHisGr->xnegro  ;
  vent->carHisGr->alturaB  = carHisGr->alturaB  ;
  vent->carHisGr->alturaN  = carHisGr->alturaN  ;
  vent->carHisGr->ppmB     = carHisGr->ppmB  ;
  vent->carHisGr->ppmN     = carHisGr->ppmN  ;
  vent->carHisGr->desvB    = carHisGr->desvB  ;
  vent->carHisGr->desvN    = carHisGr->desvN  ;
}
*/

void ponerConvenVentana (tvent vent, int *conv)
{
  int i;
  vent->conv = (int *) malloc (256 * sizeof(int));
  for (i=0; i<=255; i++)
    vent->conv[i] = conv[i];
}

/*
int * tenerConvSobreVentana (tvent vent)
{
  tvent v;
  for (v=vent; v->conv == 0L; v=v->venBase)
    if (v == v->venBase)
      v = v->imaBase->venOrig ;
  return v->conv ;
}
*/

int * tenerConvSobreVentana (tvent vent)
{
  tvent v;
  for (v=vent; v->conv == 0L; v=v->venBase)
    if ((v->conv == 0L) && (v == v->venBase))
      v = v->imaBase->venOrig ;
  return v->conv ;
}

/*

tdcaracHistoGr carhisgrDeVentana (tvent vent)
{
  tdcaracHistoGr carHgr;
  tvent v;
  v = vent;
  while (v->carHisGr == 0L) {
    // if (v->venBase == 0L) {
    if (v->venBase == v) {
      carHgr = carhisgrDeVentanaCalculado (v);
      ponerCarhisgrenVentana (v, carHgr);
      return carHgr ;
//      printf ("ocre: error en imag.carhisgrDeVentana, no encontrado carHisGr\n");
//      exit (2);
      }
    v = v->venBase ;
    }
  return v->carHisGr ;
}

*/

int ktamDeVentana (tvent vent)
{
  tvent v;
  v = vent;
  while (v->ktam == -1) {
/*
    if (v->venBase == 0L) {
*/
    if (v->venBase == v) {
      break ;
      }
    v = v->venBase ;
    }
  if (d_valori >= 10)
    printf ("ocre: imag.ktamDeVentana, ktam=%4d\n", v->ktam);
  return v->ktam ;
}

int valorintEncomImagen (char * nvariable, timagf imagf)
{
  int val;
  int n, i;
  char * donde;
  n = imagf->ncom;
  val = -1;
  for (i=0; i<n; i++) {
    donde = strstr (imagf->comen[i], nvariable);
    if (donde != NULL) {
      sscanf (donde, "%*s %d", &val);
      break;
      }
    }
  return val ;
}

void unionGventanas (tvent * nvent, tvent vent1, tvent vent2)
{
  int dx1, dx2, dx;
  int dy1, dy2, dy;
  int fx1, fx2, fx;
  int fy1, fy2, fy;
  /* si las imagenes base son distintas: excepcion */
  if (vent1->imaBase != vent2->imaBase) {
    printf ("ocre: error en imag.unionGventanas, vent1 y vent2 tienen distinata base\n");
    exit(2);
    }
  dx1 = vent1->dx;
  dy1 = vent1->dy;
  fx1 = dx1 + vent1->tx - 1;
  fy1 = dy1 + vent1->ty - 1;
  dx2 = vent2->dx;
  dy2 = vent2->dy;
  fx2 = dx2 + vent2->tx - 1;
  fy2 = dy2 + vent2->ty - 1;
  dx  = min (dx1, dx2);
  dy  = min (dy1, dy2);
  fx  = max (fx1, fx2);
  fy  = max (fy1, fy2);
  ventanaEnVentana (nvent, vent1->imaBase->ven0, dx, dy, fx-dx+1, fy-dy+1);
}

void intervaloCentrado (int *dxi, int *dxf, int tg, int tm, int tp, int dxp, int escala )
{
  int xi, xf, cdgv;
  if ( (tg - 1) <= ((tm -1)/escala) ) {
    xi = 0;
    xf = tg - 1;
    }
  else {
    cdgv = dxp + tp / 2;
    xi = cdgv - (tm / (escala * 2)) ;
    xf = xi + (tm - 1) / escala ;
    if ( xi < 0 ) {
      xi = 0;
      xf = (tm - 1) / escala ;
      }
    else if (xf > (tg - 1) ) {
      xf = tg -1 ;
      xi = xf - (tm - 1) / escala ;
      }
    }
  *dxi = xi;
  *dxf = xf;
}

void ventanaAlrededor (tvent *nvent, tvent vent, int tx, int ty, int escala) 
{
  int xi, xf, yi, yf;
  tvent v0;
  v0 = vent->imaBase->ven0;
  intervaloCentrado (&xi, &xf, v0->tx, tx, vent->tx, vent->dx, escala );
  intervaloCentrado (&yi, &yf, v0->ty, ty, vent->ty, vent->dy, escala );
  ventanaEnVentana (nvent, v0, xi, yi, xf-xi+1, yf-yi+1);
}

void ventanaVertDeVentanaIncl (tvent * nventi, tvent vent)
{
  timagf imagg;
  timagf imagb;
  int incl, desx;
  int tx, ty, x, y, tam;
  char ** pix, ** pixg;
  int xp;
  int dxs;
  incl   = vent->incl;
  ty    = vent->ty;
  dxs = inclf_desvx(incl, ty-1);
  tx    = vent->tx - abs(dxs);
  tx    = max(tx,1);      // para evitar tx == 0; 20091012
  imagb = vent->imaBase ;
  imagg = imagfalloc ();
  imagg->tx      = tx;
  imagg->ty      = ty;
  tam = tx * ty;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;   
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  /**/
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  xp = (incl > 0) ? 0 : - dxs ;
  for (y=0; y<ty; y++){
    desx = xp + inclf_desvx(incl, y);
    for (x=0; x<tx; x++) 
      pixg[y][x] = pix[y][x+desx] & 0x0FF ;
    }
  *nventi = imagg->ven0 ;
}

void ventanaLimpConMargenDeVentanaIncl (tvent * nventi, tvent vent, int fondo,
                                        int marg)
{
  int incl, desx;
  int tx, ty, x, y;
  char ** pix;
  int xp, xu;
  timagf  nimag;
  incl   = vent->incl;
  tx     = vent->tx;
  ty     = vent->ty;
  creaImagenAmpliadaConMargen (&nimag, vent, 1, 1, marg, fondo);
  ventanaEnVentana (nventi, nimag->ven0, marg, marg, tx, ty);
  pix  = (*nventi)->pix ;
  pon_vprim_vult (incl, ty, tx, &xp, &xu);
  // pon fondo en triangulos
  for (y=0; y<ty; y++){
    desx = inclf_desvx(incl, y);
    for (x=0; x<tx; x++) {
      if (x < (xp + desx))
        pix [y][x] = fondo ;
      if (x > (xu + desx))
        pix [y][x] = fondo ;
      }
    }
}

// la base de ampliacion va a ser vent1, incognita,
//              y se tanteara con vent2, pruebas.
void ventanaLimpConMargenPara2vents (tvent * nventi, tvent vent1, tvent vent2,
		                     int delta2resp1, int fondo, int marg)
{
  int margen2y, margen2x, margen2;
  int sobresaleNorte, sobresaleSur;
  sobresaleNorte = max(0, -delta2resp1);
  sobresaleSur   = max(0, vent2->ty - vent1->ty + delta2resp1);
  margen2y = max(0, sobresaleNorte + sobresaleSur) + marg;
  margen2x = max(0, vent2->tx - vent1->tx) / 2 + 1 + marg;
  margen2  = max(margen2x, margen2y);
  ventanaLimpConMargenDeVentanaIncl (nventi, vent1, fondo, margen2);
}

void ventanaLimpDeVentanaIncl (tvent * nventi, tvent vent, int fondo)
{
  ventanaLimpConMargenDeVentanaIncl (nventi, vent, fondo, 0);
}

/*
// lo borrare ?, o tengo que cambiar la inclinacion 
// inclinacion _tz 
void ventanaLimpDeVentanaIncl2 (tvent * nventi, tvent vent, int fondo)
{
  int inc, desx;
  int tx, ty, x, y;
  char ** pix;
  int xp, xu, imas1;
  timagf  nimag;
  copiaImagenDeVentana (&nimag, vent);
  inc   = vent->incl;
  tx    = vent->tx;
  ty    = vent->ty;
  pix  = nimag->ven0->pix ;
  // pon_cp_cu_imas1 (inc, vent->tx, &xp, &xu, &imas1) ;
  pon_vprim_vult (incl, ty, tx, &xp, &xu);
  for (y=0; y<ty; y++){
    // desx = (y * imas1) / ty ;
    desx = inclf_desvx(incl, y);
    for (x=0; x<tx; x++) {
      if (x < (xp + desx))
        pix [y][x] = fondo ;
      if (x > (xu + desx))
        pix [y][x] = fondo ;
      }
    }
  *nventi = nimag->ven0 ;
}
*/

void imprimeConv (int * conv)
{
 int i;
 printf ("ocre.imag.imprimeConv\n");
 for (i=0; i<=255; i++) {
   printf (" %3d",conv[i]);
   if ((i%20)==19)
     printf ("\n");
   }
 printf ("\n");
}

void cdgVentana (int *cdgx, int *cdgy, tvent vent, int ampl)
{
 int * conv;
 int x, y, tx, ty;
 char ** pix;
 int sumpix, sumxpix, sumypix;
 int sumpixPoramplEntredos;
 int pixconv;
 // conv = vent->conv;
 conv = tenerConvSobreVentana (vent); 
 // imprimeConv (conv);
 pix  = vent->pix;
 tx   = vent->tx;
 ty   = vent->ty;
 sumpix  = 0;
 sumxpix = 0;
 sumypix = 0;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   pixconv = 255 - conv[(pix[y][x] & 0xFF)];
   sumpix  += pixconv ;
   sumxpix += pixconv * x ;
   sumypix += pixconv * y ;
   if (d_valori >= 50)
     printf ("x=%4d y=%4d pix[y,x]=%3d, pixconv=%3d sumpix=%7d sumxpix=%9d, sumypix=%9d\n",
              x,    y,    pix[y][x]&0xFF, pixconv,  sumpix,    sumxpix,     sumypix);
   }
 sumpixPoramplEntredos = (sumpix * ampl) / 2;
 * cdgx = (sumxpix * ampl  + sumpixPoramplEntredos ) / sumpix ;
 * cdgy = (sumypix * ampl  + sumpixPoramplEntredos ) / sumpix ;
}

void maximoenVentana (int *mxx, int *mxy, int *mxp, tvent vent)
{
 int x, y, tx, ty;
 char ** pix;
 int opix;
 pix  = vent->pix;
 tx   = vent->tx;
 ty   = vent->ty;
 *mxx  = 0;
 *mxy  = 0;
 *mxp  = 0;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   opix = (pix[y][x] & 0xFF) ;
   if (opix > *mxp) {
     *mxx  = x;
     *mxy  = y;
     *mxp  = opix;
     }
   }
}

tvent seleccionaSubventana (tvent vent, char *selec)
{
  int lsel;
  tvent v;
  int i, j;
  lsel = strlen (selec);
  if (lsel < 2) {
    printf ("ocre.imag.seleccionaSubventana: error, seleccion corta\n");
    exit (40);
    }
  if (selec[0] != 'c') {
    printf ("ocre.imag.seleccionaSubventana: seleccion no comienza por 'c'\n");
    exit (40);
    }
  i = lsel - 1;
  if (selec[i] != 'r') {
    printf ("ocre.imag.seleccionaSubventana: seleccion no acaba en 'r'\n");
    exit (40);
    }
  i -- ;
  v = vent;
  while (i>0) {
    j = 1;
    while (selec[i]=='d'){
      i--; j++;
      }
    if (selec[i] != 'a') {
      printf ("ocre.imag.seleccionaSubventana: seleccion le falta una 'a'\n");
      exit (40);
      }
    if (v->lvint == 0L) {
      printf ("ocre.imag.seleccionaSubventana:  no hay subventanas\n");
      exit (40);
      }
    if (longLista(v->lvint) < j) {
      printf ("ocre.imag.seleccionaSubventana:  no hay %3d tantas subventanas\n", j);
      exit (40);
      }
    v = (tvent) (enesimoNodoDeLista (v->lvint, j) ->aitem);
    i--;
    }
  return v;
}

/* ------ misc ---------- */

Boolean ventanaMenor(tvent v1, tvent v2)
// v1  menor que  v2
{
  return ((v1->tx < v2->tx) && (v1->ty <= v2->ty)) ||
         ((v1->ty < v2->ty) && (v1->tx <= v2->tx)) ;
}

Boolean ventanaAlsur(tvent v1, tvent v2)
// v1  al sur de  v2  , algo de v1 bajo v2
{
  return ( ((v1->dx + v1->tx) > v2->dx) &&
           ((v2->dx + v2->tx) > v1->dx)  ) &&
	 ( (v1->dy + v1->ty) > (v2->dy + v2->ty) ) ;
}

// ------ a borrar cuando no haya 'tvvent' ----------
//         y vaya todo con listas

tvvents vventDeLista (lista l)
{
  tvvents vvents;
  tnodol nodol;
  int n, i;
  n = longLista (l);
  vvents = vventsalloc (n);
  nodol = l->primero;
  for (i=0; i<n; i++) {
    vvents->ventanas[i] = nodol->aitem;
    nodol = nodol->siguiente;
    }
  return vvents ;
}

void umbralizaVentana (tvent vent, int gr)
{
 int x, y, tx, ty;
 char ** pix;
 pix  = vent->pix;
 tx   = vent->tx;
 ty   = vent->ty;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   if ((pix[y][x] & 0xFF) > gr)
     pix[y][x] = 255;
   else
     pix[y][x] = 0;
   }
}

Boolean llegaGrisV (tvent vent, int y, int gr)
{
  int x, tx;
  Boolean llg;
  char ** pix;
//  if (vent->incl != 0)
//    return llegaGrisIncl (vent, y, gr) ;
  llg = FALSE ;
  tx  = vent->tx;
  pix = vent->pix;
  for (x=0; x<tx; x++)
    if ((pix[y][x] & 0xFF) < gr)
      llg = TRUE ;
  return llg ;
}

void ajustadaV (tvent *nvent, tvent vent, int gr)
{
  int y0, y1, ty;
  ty =  vent->ty;
  y0  = 0;
  // desplaza hacia abajo el limite superior
  while ((y0 < ty) && ! llegaGrisV (vent, y0, gr))
    y0 ++ ;
  y1 = ty - 1;
  // desplaza hacia arriba el limite inferior
  while ((y1 >y0) && ! llegaGrisV (vent, y1, gr))
    y1 -- ;
  ventanaEnVentanaLargHor (nvent, vent, y0, y1-y0+1);
  if (d_valori >= 40)
    printf ("ocre: ajustadaV\n") ;
}

Boolean llegaGrisH (tvent vent, int x, int gr)
{
  int y, ty;
  Boolean llg;
  char ** pix;
//  if (vent->incl != 0)
//    return llegaGrisIncl (vent, y, gr) ;
  llg = FALSE ;
  ty  = vent->ty;
  pix = vent->pix;
  for (y=0; y<ty; y++)
    if ((pix[y][x] & 0xFF) < gr)
      llg = TRUE ;
  return llg ;
}

void ajustadaH (tvent *nvent, tvent vent, int gr)
{
  int x0, x1, tx;
  tx =  vent->tx;
  x0  = 0;
  // desplaza hacia la derecha el limite izquierdo
  while ((x0 < tx) && ! llegaGrisH (vent, x0, gr))
    x0 ++ ;
  x1 = tx - 1;
  // desplaza hacia la izquierda el limite derecho
  while ((x1 >x0) && ! llegaGrisH (vent, x1, gr))
    x1 -- ;
  ventanaEnVentanaLargVer (nvent, vent, x0, x1-x0+1);
  if (d_valori >= 40)
    printf ("ocre: ajustadaH\n") ;
}

void ajustadaVH (tvent *nvent, tvent vent, int gr)
{
  tvent venti;
  ajustadaV (&venti, vent,  gr);
  ajustadaH (nvent,  venti, gr);
  (*nvent)->venBase = vent;
  destruyeVentana (venti);
  if (d_valori >= 40)
    printf ("ocre: ajustadaVH\n") ;
}

// ajusta una ventana extendiendola 
void ajustadaVHext (tvent *nvent, tvent vent, tvent ventmx, int gr)
{
  int dx, fx, dy, fy, dxmn, fxmx, dymn, fymx;
  tvent venti, venti2, venti3;
  // describeVentana (vent);
  // describeVentana (ventmx);
  dxmn = ventmx->dx;
  dymn = ventmx->dy;
  fxmx = ventmx->dx + ventmx->tx - 1;
  fymx = ventmx->dy + ventmx->ty - 1;
  copiaVentana (&venti, vent);
  while ((dx>dxmn) || (dy>dymn) || (fx<fxmx) || (fy<fymx)) {
    // describeVentana (venti);
    dx = venti->dx;
    dy = venti->dy;
    fx = venti->dx + venti->tx - 1;
    fy = venti->dy + venti->ty - 1;
    dx = max(dxmn, dx-1);
    dy = max(dymn, dy-1);
    fx = min(fxmx, fx+1);
    fy = min(fymx, fy+1);
    ventanaDeVentana (&venti2, venti->imaBase->ven0,
                      dx, dy, fx-dx+1, fy-dy+1);
    ajustadaVH (&venti3, venti2, gr);
    destruyeVentana (venti2);
    if ( (venti3->dx == venti->dx) && (venti3->dy == venti->dy) &&
         (venti3->tx == venti->tx) && (venti3->ty == venti->ty)   )
      break;
    destruyeVentana (venti);
    copiaVentana (&venti, venti3);
    }
  *nvent = venti3;
  if (d_valori >= 40)
    printf ("ocre: ajustadaVHext\n") ;
}
