
#include <gtk/gtk.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <sys/wait.h>
#include <unistd.h>

#include "arbolesOcre.h"
#include "base.h"
#include "caracteris.h"
#include "convcar.h"
#include "distrib.h"
#include "glifos.h"
#include "grises.h"
#include "imag.h"
#include "imagx.h"
// #include "inclfont.h"
#include "inclina0.h"
#include "interface.h"
#include "opcns.h"
#include "parecido.h"
#include "pauta.h"
#include "pixmap.h"
#include "segmenta.h"
#include "tfd2d.h"

#include "id3/arbolesid3.h"

void migets (int fd, char *s)
{
  int i;
  i = 0;
  while ((i==0) ||
         ((s[i-1] != '\n') && (i < 128))){  
    read (fd, & s[i], 1);
    i++ ;
    }
  s [i-1] = '\0';
}

tvent ventPreg;

static int prim = 0;
static GtkWidget *window1;
extern char de_entry[];

static int npregs=0; 

int cuantasPreguntas ()
{
  return npregs ;
}

void presentayPregunta (char *resp, tvent vent, char *nf)
{
  ventPreg = vent;
  if (prim == 0) {
    window1 = create_window1 ();
    gtk_widget_show (window1);
    gtk_main ();
    prim ++ ;
    }
  else {
    configureRep ();
    gtk_main ();
    }
  strcpy (resp, de_entry) ; 
  npregs ++;
  if (d_valori >= 10)
    printf ("presentayPregunta %s\n", resp) ;
}

void presentayPregunta2 (char *resp, tvent vent, char *nf)
{
  int nh;
  int resul;
  presentaVentana (&nh, vent, nf, 3);
  migets (0, resp) ;
  kill (nh, 9);
  wait (&resul);
  if (d_valori >= 10)
    printf ("presentayPregunta %s\n", resp) ;
}

void trazaReconoceId3 (char *nproced, int nprp, struct tpropues *lprop)
{
  if (d_valori >= 20)
    printf ("ocre: %s\n", nproced);
  /* 4 */
  if (d_valori >= 20) {
    printf ("%2d", nprp);
    if (nprp == 1)
      printf (" %s", lprop[0].nombre);
    printf ("\n");
    }
}

int reconoceId3Rect (char * buf, int *indcsi, int *indcna, tvent vent)
{
  tmatcomplejo m;
  int crct[400] ;
  struct tpropues lprop [20];
  int nprp;
  char buf0[128];
  int dyNorm, dy2Norm, tyNorm;
  if (vent->venlimpia == 0L)
    transfVent0 (&m, vent);
  else
    transfVent0 (&m, vent->venlimpia);
  alineamientoNormalizado (&dyNorm, &dy2Norm, &tyNorm, vent->GLifoDeVen);
  caracterist (crct, m, 5, 5, vent->tx, vent->ty, dyNorm, dy2Norm, tyNorm);
  // caracterist (crct, m, 5, 5, vent->tx, vent->ty, 96, 144, 48); // prueba numPg
  if (d_valori >=50) {
    escribeCaracteristicas (crct, 5, 5);
    }
  liberaMatrizComplejo (m, /* vent->ty */ TF_TAMMAXY );
  // crct[2] =  96; crct[3] = 144; crct[4] =  48; 
//  if (*indcsi == 0)
    clasificaConArboles (crct, lprop, 6, &nprp);
//  else
//    clasificaConArbolesUmbr (crct, lprop, 6, &nprp, 0.35);
  *indcsi = lprop[0].res[1];
  *indcna = lprop[0].narb;
  if (nprp == 1) {
    strcpy (buf0,  &(lprop[0].nombre[6]));
    sutf8DeUstr (buf, buf0);
    }
  trazaReconoceId3 ("reconoceId3Rect", nprp, lprop);
  return (nprp == 1);
}

int reconoceId3InclLimp (char * buf, int *indcsi, int *indcna, tvent vent)
{
  tmatcomplejo m;
  int crct[400] ;
  struct tpropues lprop [20];
  int nprp;
  char buf0[128];
  int dyNorm, dy2Norm, tyNorm;
  tvent ventl;
  int fondo;
  tdcaracHistoGr carHisGr;
  carHisGr = carhisgrDeVentana (vent);
  fondo = carHisGr->xblanco ;
  ventanaLimpDeVentanaIncl (&ventl, vent, fondo);
  transfVent0 (&m, ventl);
  alineamientoNormalizado (&dyNorm, &dy2Norm, &tyNorm, vent->GLifoDeVen);
  caracterist (crct, m, 5, 5, vent->tx, vent->ty, dyNorm, dy2Norm, tyNorm);
  if (d_valori >=50) {
    escribeCaracteristicas (crct, 5, 5);
    }
  liberaMatrizComplejo (m, /* vent->ty */ 200);
  // crct[2] =  96; crct[3] = 144; crct[4] =  48; 
  clasificaConArbolesCur (crct, lprop, 6, &nprp);
  *indcsi = lprop[0].res[1];
  *indcna = lprop[0].narb;
  if (nprp == 1) {
    strcpy (buf0,  &(lprop[0].nombre[6]));
    sutf8DeUstr (buf, buf0);
    }
  trazaReconoceId3 ("reconoceId3InclLimp", nprp, lprop);
  return (nprp == 1);
}

int reconoceId3InclEnder (char * buf, int *indcsi, int *indcna, tvent vent)
{
  tmatcomplejo m;
  int crct[400] ;
  struct tpropues lprop [20];
  int nprp;
  char buf0[128];
  int dyNorm, dy2Norm, tyNorm;
  tvent ventr;
  ventanaVertDeVentanaIncl (&ventr, vent);
  transfVent0 (&m, ventr);
  alineamientoNormalizado (&dyNorm, &dy2Norm, &tyNorm, vent->GLifoDeVen);
  caracterist (crct, m, 5, 5, vent->tx, vent->ty, dyNorm, dy2Norm, tyNorm);
  if (d_valori >=50) {
    escribeCaracteristicas (crct, 5, 5);
    }
  liberaMatrizComplejo (m, /* vent->ty */ 200);
  // crct[2] =  96; crct[3] = 144; crct[4] =  48; 
//  if (*indcsi == 0)
    clasificaConArboles (crct, lprop, 6, &nprp);
//  else            //  -1?
//    clasificaConArbolesUmbr (crct, lprop, 6, &nprp, 0.35);
  *indcsi = lprop[0].res[1];
  *indcna = lprop[0].narb;
  if (nprp == 1) {
    strcpy (buf0,  &(lprop[0].nombre[6]));
    sutf8DeUstr (buf, buf0);
    }
  trazaReconoceId3 ("reconoceId3InclEnder", nprp, lprop);
  return nprp == 1 ;
}

/*
int reconoceId3Incl (char * buf, int *indcsi, int *indcna, tvent vent)
{
  if (reconoceId3InclLimp (buf, indcsi, indcna, vent))
    return TRUE ;
  else
    return reconoceId3InclEnder (buf, indcsi, indcna, vent);
}
*/

int reconoceId3 (char * buf, int *indcsi, int *indcna, tvent vent)
{
  if (vent->incl == 0)
    return reconoceId3Rect (buf, indcsi, indcna, vent);
  else  { // tvent->incl != 0
    // return reconoceId3Incl (buf, indcsi, indcna, vent);
    if (reconoceId3InclLimp (buf, indcsi, indcna, vent))
      return TRUE ;
    else
      return reconoceId3InclEnder (buf, indcsi, indcna, vent);
   }
}

void reconoceChar (tglifo glifoChar, int nivq)
{
  int reconocido;
  char resp [128];
  tglifo glifoParecido;
  tvent vent;
  int indcsi, indcna;
  vent    = glifoChar->venDeGlifo;
  indcsi = 0;                     // requisito normal, p.ej. 3/5
  reconocido = FALSE;
  if ( !reconocido ) {
    // printf ("reconoceCar tamaño 0?\n");  //
    if (vent->ty == 0 || vent->tx ==0) {
      // printf ("reconoceCar tamaño 0 SI\n");  //
      reconocido = TRUE;
      glifoChar->tipo  = glifArtf;
      glifoChar->recon = reconMisc;
      }
    }
  if ( !reconocido ) {
    // printf ("reconoceCar id3?\n");  //
    if ( reconoceId3 (resp, &indcsi, &indcna, vent)) {
      // printf ("reconoceCar id3:%s\n", resp);  //
      reconocido = TRUE;
      ponLetGlifo (glifoChar, resp);
      glifoChar->recon = reconId3ft ;
      glifoChar->recindc = indcsi ;
      corregirGlifocharPorPosy (glifoChar, resp) ;  //
      aniadeGlifoafinlista (lglmuestra, glifoChar);
      }
    }
  if ( !reconocido ) {
//    if ( ventParecidaAntes (&glifoParecido, vent) ) {
    // printf ("reconoceCar parecido antes?\n");  //
    if ( glifParecidoYensusitioAntes (&glifoParecido, glifoChar) ) {
      // printf ("reconoceCar parecido antes: %s\n", glifoParecido->letras);  //
      reconocido = TRUE;
      ponLetGlifo (glifoChar, glifoParecido->letras);
      glifoChar->recon     = reconComp ;
      glifoChar->recparecc = glifoParecido->recparecc+1 ;
      }
    }
/**/
  if ( !reconocido ) {
    int ktam;
    ktam = ktamDeVentana (vent);
    // printf ("reconoceCar parecido ktam: %4d  tam.ven: %4d %4d\n", ktam, vent->tx, vent->ty);  //
    if ((vent->tx < ktam) && (vent->ty < ktam)){
      glifoChar->tipo = glifArtf ;
      glifoChar->recon = reconMisc;
      reconocido = TRUE;
      }
    }
/**/
  // printf ("reconoceCar q_valori: %4d nivq: %4d\n", q_valori, nivq);  //
  if (q_valori >= nivq) {
    if ( !reconocido & ! (s_opcion || S_opcion)) {
      // printf ("reconoceCar presenta y pregunta\n");  //
      //  resp[0] = 'w' ; resp[1]= '\0';   // parcheCino
      presentayPregunta (resp, vent, "sal22.pgm");
      if (resp[0] != '\0') {
        ponLetGlifo (glifoChar, resp);
        glifoChar->recon = reconPreg ;
        aniadeGlifoafinlista (lglmuestra, glifoChar);
        reconocido = TRUE;
        }
      else
	reconocido = FALSE;
      }
    if ( !reconocido & (s_opcion || S_opcion)) {
      npregs ++;                    // quiza mejor otra variable
      }
    }
/**/
  if ( !reconocido ) {
    strcpy (resp, "_");
    ponLetGlifo (glifoChar, resp);
    reconocido = TRUE;
    }
/**/
}

void reconoceCharI (tglifo glifoChar, int nivsi)
{
  int reconocido;
  char resp [128];
  tvent vent;
  int indcsi, indcna;
  indcsi = nivsi;             // requisito  p.ej. -1 => 2/5
  vent    = glifoChar->venDeGlifo;
  reconocido = FALSE;
  if ( !reconocido ) {
    // printf ("reconoceCar id3?\n");  //
    if ( reconoceId3 (resp, &indcsi, &indcna, vent)) {
      // printf ("reconoceCar id3:%s\n", resp);  //
      reconocido = TRUE;
      ponLetGlifo (glifoChar, resp);
      glifoChar->recon = reconId3ft ;
      glifoChar->recindc = indcsi ;
      corregirGlifocharPorPosy (glifoChar, resp) ;  //
      aniadeGlifoafinlista (lglmuestra, glifoChar);
      }
    }
  if ( !reconocido ) {
    strcpy (resp, "_");
    ponLetGlifo (glifoChar, resp);
    reconocido = TRUE;
    }
}

int espacioEntreVentanas (tvent ventAnt, tvent ventSig)
{
  int xuAntSup, xuAntInf, xpSigSup, xpSigInf;
  int dsup, dinf ;
  if (ventAnt->incl >= 0) {
    xuAntSup = ventAnt->tx - 1 - inclf_desvx(ventAnt->incl, ventAnt->ty - 1) ;
    xuAntInf = ventAnt->tx - 1 ;
    }
  else /* ventAnt->incl < 0 */ {
    xuAntSup = ventAnt->tx - 1 ;
    xuAntInf = ventAnt->tx - 1 + inclf_desvx(ventAnt->incl, ventAnt->ty - 1) ;
    }
  if (ventSig->incl >= 0) {
    xpSigSup = 0 ;
    xpSigInf = inclf_desvx(ventSig->incl, ventSig->ty - 1) ;
    }
  else /* ventSig->incl < 0 */ {
    xpSigSup = - inclf_desvx(ventSig->incl, ventSig->ty - 1) ;
    xpSigInf = 0 ;
    }
  dsup = (ventSig->dx - ventAnt->dx) + xpSigSup - xuAntSup - 1;
  dinf = (ventSig->dx - ventAnt->dx) + xpSigInf - xuAntInf - 1;
  return min(dsup, dinf) ;
}

/*
void aniadeQuizaBlanco (tlistadglifo ldglifo, tvent ventAnt, tvent ventSig, int altura)
{
  int espacio;
  if ((ventAnt->incl == 0) & (ventSig->incl == 0))
    espacio = ventSig->dx - ventAnt->dx - ventAnt->tx ;
  else  // (ventAnt->incl != 0) | (ventSig->incl != 0) 
    espacio = espacioEntreVentanas (ventAnt, ventSig) ;
  if (espacio > (altura / 6) )
    aniadeGlifoafinlista (ldglifo, glifoBlanNuevo ());
}
*/

void reconocePalabra (tglifo glifoPalabra)
{
  tnodol nodol;
  lista caracteres;
  tvent vent;
  tglifo glifoChar;
  tlistadglifo ldglifo;
  ldglifo = glifoPalabra->listaGlifos;
  vent    = glifoPalabra->venDeGlifo;
  // lineasBase (&(glifoPalabra->base), &(glifoPalabra->alturax), vent);
  caracteres = vent->lvint;
  for (nodol = caracteres->primero; nodol != (tnodol)0L; nodol = nodol->siguiente){
    tvent ventcar;
    ventcar = (tvent) nodol->aitem;
    glifoChar = glifoLetNuevo ("0?");
    adoptaGlifo (glifoPalabra, glifoChar);
    casaGlifoVent (glifoChar, ventcar);
    reconoceChar (glifoChar, 7);
    }
}

//void reconoceLinea (tglifo glifoLinea)
void reconoceLinea (tglifo glifoLinea, tpgen nada)
{
  tnodol nodol;
  lista palabras;
  tvent vent;
  tglifo glifoPal;
  tglifo glifoBlan;
  tlistadglifo ldglifo;
  ldglifo = glifoLinea->listaGlifos;
  vent    = glifoLinea->venDeGlifo;
  lineasBase (&(glifoLinea->base), &(glifoLinea->alturax), vent);
  palabras = vent->lvint;
  for (nodol = palabras->primero; nodol != (tnodol)0L; nodol = nodol->siguiente) {
    tvent ventpal;
    ventpal = (tvent) nodol->aitem;
    glifoPal = glifoCompPalNuevo ();
    adoptaGlifo (glifoLinea, glifoPal);
    casaGlifoVent (glifoPal, ventpal);
    reconocePalabra (glifoPal);
    if (nodol != palabras->ultimo) {
      glifoBlan = glifoBlanNuevo ();
      adoptaGlifo (glifoLinea, glifoBlan);
      }
//    aniadeQuizaBlanco (ldglifo, palabras[i], palabras[i+1], vent->ty);
    }
  aniadeGlifoafinlista (ldglifo, glifoClinNuevo ());
//
}

void reconoceInterlineados (tglifo glifoColumnaP)
{
  int abase, abaseant;
  tnodolglifo nodolGlifo;
  tglifo glifoLin;
  int i;
  int seps [400];
  int cseps [400];
  int ncseps;
  int umbsep;
  if ((longLista(glifoColumnaP->venDeGlifo->lvint)>2)) {
    // printf ("longitud lista: %3d\n", longLista(glifoColumnaP->venDeGlifo->lvint));
    //
    i = 0;
    for (nodolGlifo = glifoColumnaP->listaGlifos->primero;
         nodolGlifo !=  0L; nodolGlifo = nodolGlifo->siguiente) {
      glifoLin = nodolGlifo->aglifo;
      abase = glifoLin->venDeGlifo->dy + glifoLin->base ;
      if (nodolGlifo != glifoColumnaP->listaGlifos->primero)
         seps [i++] = abase-abaseant;
      abaseant = abase;
      }
    agrupa (cseps, &ncseps, seps, i, 4);
    // printf ("cseps[0]: %3d, ncseps: %3d\n", cseps[0], ncseps);
    umbsep = (cseps[0] * 13)/10;
    //
    for (nodolGlifo = glifoColumnaP->listaGlifos->primero;
         nodolGlifo !=  0L; nodolGlifo = nodolGlifo->siguiente) {
      glifoLin = nodolGlifo->aglifo;
      abase = glifoLin->venDeGlifo->dy + glifoLin->base ;
      if (nodolGlifo != glifoColumnaP->listaGlifos->primero) {
	if (abase-abaseant > umbsep) {
	  tglifo glifoEspv;
          // printf ("reconoceInterlineados:introduce glifo espaciado vertical\n");
	  glifoEspv = glifoEspvNuevo ();
	  aniadeGlifoalistaAntes (glifoColumnaP->listaGlifos, glifoEspv, nodolGlifo);
          }
        // printf ("reconoceInterlineados %4d %4d\n", abase, abase-abaseant);
        }
      // else 
        // printf ("reconoceInterlineados %4d\n", abase);
      abaseant = abase;
      }
    //
    }
}

void reconoceColumnaP (tglifo glifoColumnaP)
{
  tnodol nodoprim, nodoult, nodocom, nodofin;
  tnodol nodol;
  tvent vent;
  tglifo glifoLinea;
  vent = glifoColumnaP->venDeGlifo;
  nodoprim = vent->lvint->primero ;
  nodoult = vent->lvint->ultimo ;
  // elimina lineas primera y ultima si tocan lineas norte o sur
  if (longLista(vent->lvint)>2) {
    if ( ((tvent)nodoprim->aitem)->dy == 1){
      nodocom = nodoprim->siguiente;
      // nodocom = nodoprim;
      }
    else
      nodocom = nodoprim;
    nodoult = vent->lvint->ultimo;
    if ( ( ((tvent)nodoult->aitem)->dy +
           ((tvent)nodoult->aitem)->ty  ) >=
                                     vent->ty ) {
      nodofin = nodoult->anterior;
      // printf ("reconoce.reconoceColumnaP: eliminando ultima linea\n");
      }
    else
      nodofin = nodoult;
    }
  else {
    nodocom = nodoprim;
    nodofin = nodoult;
    }
  // asocia glifo <-> ventana
  for (nodol = nodocom; nodol != nodofin->siguiente; nodol = nodol->siguiente) {
    glifoLinea = glifoCompLinNuevo ();
    adoptaGlifo (glifoColumnaP, glifoLinea);
    casaGlifoVent (glifoLinea, (tvent) nodol->aitem);
    }
  // reconoce lineas
  /*
  {
  tnodolglifo nodolGlifo;
  nodolGlifo = glifoColumnaP->listaGlifos->primero;
  while (nodolGlifo !=  0L) {
    reconoceLinea (nodolGlifo->aglifo);
    nodolGlifo = nodolGlifo->siguiente;
    }
  }
  */
  aplicaGtRFncD (glifoColumnaP, glifCompLin, reconoceLinea, NULL);
  reconoceInterlineados (glifoColumnaP);
}
